#version 330

// Position of the vertex
in vec4 position;
// Normal vector of the vertex
in vec3 normal;

uniform mat4 model_matrix;
uniform mat4 PVM_matrix;
uniform mat3 normal_matrix;

// Normal vector in world space
out vec3 VS_normal_ws;
// Vertex position in world space
out vec3 VS_position_ws;

void main()
{
    VS_normal_ws = normalize(normal_matrix * normal);
    VS_position_ws = (model_matrix * position).xyz;
    gl_Position = PVM_matrix * position;
}
